package DE.fub.inf.JVM.ClassGen;

/** 
 * IFNONNULL - Branch if reference is not null
 *
 * Stack: ..., reference -> ...
 *
 * @version $Id: IFNONNULL.java,v 1.3 1998/10/22 14:06:08 dahm Exp $
 * @author  <A HREF="http://www.inf.fu-berlin.de/~dahm">M. Dahm</A>
 */
public class IFNONNULL extends IfInstruction {
  /**
   * Empty constructor needed for the Class.newInstance() statement in
   * Instruction.readInstruction(). Not to be used otherwise.
   */
  IFNONNULL() {}

  public IFNONNULL(InstructionHandle target) {
    super(IFNONNULL, target);
  }

  /**
   * @return negation of instruction
   */
  public IfInstruction negate() {
    return new IFNULL(target);
  }
}
