package DE.fub.inf.JVM.ClassGen;

/** 
 * IF_ICMPLT - Branch if int comparison succeeds
 *
 * Stack: ..., value1, value2 -> ...
 *
 * @version $Id: IF_ICMPLT.java,v 1.3 1998/10/22 14:06:13 dahm Exp $
 * @author  <A HREF="http://www.inf.fu-berlin.de/~dahm">M. Dahm</A>
 */
public class IF_ICMPLT extends IfInstruction {
  /**
   * Empty constructor needed for the Class.newInstance() statement in
   * Instruction.readInstruction(). Not to be used otherwise.
   */
  IF_ICMPLT() {}

  public IF_ICMPLT(InstructionHandle target) {
    super(IF_ICMPLT, target);
  }

  /**
   * @return negation of instruction
   */
  public IfInstruction negate() {
    return new IF_ICMPGE(target);
  }
}
